/*
 * Legato is a configurable, lightweight web mapping client that can be
 * easily embedded into web pages and portals, CMS and individual web
 * applications. Legato is implemented in JavaScript and based on the
 * popular open source library OpenLayers.
 *
 * Copyright (C) 2010  disy Informationssysteme GmbH, http://www.disy.net
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Legato.I18n.MessageSource = OpenLayers.Class( {
  locale :null,
  messages :null,
  initialize : function(options) {
    OpenLayers.Util.extend(this, options);
    if (!Legato.Lang.ObjectUtils.exists(this.locale)) {
      this.locale = (new Legato.I18n.BrowserLocaleFactoryBean()).getInstance();
    }
    if (!Legato.Lang.ObjectUtils.exists(this.messages)) {
      this.messages = Legato.I18n.Messages;
    }
  },

  containsMessage : function(key) {
    var dictionary = this.messages.dictionaries[this.locale];

    if (Legato.Lang.ObjectUtils.exists(dictionary)) {
      var message = dictionary[key];
      if (Legato.Lang.ObjectUtils.exists(message)) {
        return true;
      } else {
        return false;
      }
    } else {
      return false;
    }
  },

  getMessage : function(key, context) {

    var dictionary = this.messages.dictionaries[this.locale];

    if (Legato.Lang.ObjectUtils.exists(dictionary)) {
      var message = dictionary[key];
      if (Legato.Lang.ObjectUtils.exists(message)) {
        return OpenLayers.String.format(message, context);
      } else {
        return '???' + key + '???';
      }
    } else {
      return '???' + key + '???';
    }
  },
  CLASS_NAME :'Legato.I18n.MessageSource'
});

Legato.I18n.MessageSource.Bean = Legato.Beans.Object.Extend(
    'Legato.I18n.MessageSource',
    //
    Legato.I18n.QName('MessageSource'),
    //
    {
      _constructor :Legato.I18n.MessageSource,
      options : {
        locale :Legato.Lang.String
      }
    });
