/*
 * Legato is a configurable, lightweight web mapping client that can be
 * easily embedded into web pages and portals, CMS and individual web
 * applications. Legato is implemented in JavaScript and based on the
 * popular open source library OpenLayers.
 *
 * Copyright (C) 2010  disy Informationssysteme GmbH, http://www.disy.net
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Component: olc:DrawFeature
 *
 * Draws point, line or polygon features on a vector layer.
 * 
 * Inherits from:
 * - <olc:Control>
 * 
 * See also:
 * - <olc> namespace
 * - <OpenLayers.Control.DrawFeature>
 * - <lc:DrawFeature>
 * - <lc:DrawPoint>
 * - <lc:DrawLineString>
 * - <lc:DrawPolygon>
 * - <lc:DrawBox>
 * - <lc:ModifyFeature>
 * - <lc:ModifyPoint>
 * - <lc:ModifyLineString>
 * - <lc:ModifyPolygon>
 */
OpenLayers.Control.DrawFeature.Bean = OpenLayers.Control.Bean.Extend(
//
'OpenLayers.Control.DrawFeature',
//
Legato.OpenLayers.Control.QName('DrawFeature'),
//
{
	_constructor : OpenLayers.Control.DrawFeature,
	constructorArguments : {
		/**
		 * Element: layer
		 * {<oll:Vector>} 
		 */
		layer : OpenLayers.Layer.Bean,
		/**
		 * Element: handler
		 * {Function} 
		 */
		handler : Legato.Lang.Function
	},
	constructorOrder : [ 'layer', 'handler' ],
	options : {
		/**
		 * Element: featureAdded
		 * {Function} Called after the feature is added
		 */
		featureAdded : Legato.Lang.Function,
		/**
		 * Element: handlerOptions
		 * {Object} Used to set non-default properties on the control's handler
		 */
		handlerOptions : Legato.Beans.Object
	}
});